/* $Id$
 * vim: set tw=80 ts=4 sw=4 : */

#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU /* to get strndup */
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include <time.h>
#include <stdarg.h>
#include <strings.h>

#include "subid.h"

int log_fmt(char* fmt, ...) {
	FILE *logfile = NULL;
	char *ts = NULL;
	time_t t;

	va_list ap;
	va_start(ap,fmt);

	/* put the current time into t */
	time(&t);
	/* get the time as a string */
	ts = ctime(&t);
	if (!ts) {
		fprintf(stderr,"can't find out the time\n");
		return 0;
	}
	/* strip the newline */
	*(index(ts,'\n')) = '\0';
	
	/* TODO: add flock()ing or similar */
	logfile = fopen(log_file_name,"a+");
	if (!logfile) {
		fprintf(stderr,"could not open the log file\n");
		return 0;
	}

	fprintf(logfile, "%s: ", ts);
	vfprintf(logfile, fmt, ap);
	fprintf(logfile, "\n");
	fclose(logfile);

	return 1;
}


